#include<stdlib.h>
#include<stdio.h>
#include <string.h>

#include "bin_read.h"
#include "scia_common.h"
#include "scia_defs.h"
#include "scia_L2N.h"

/* Array with DSD Names : declaration in scia_L2.h*/


char DS_NAME_SCI_NL__2P [50][29] = {
    "SUMMARY_QUALITY",
    "STATE_GEOLOCATION",
    "STATES",
    "GEOLOCATION",
    "CLOUDS_AEROSOL",
    "DOAS_0_O3",
    "DOAS_1_NO2",
    "DOAS_1_H2O",
    "DOAS_1_O3",
    "DOAS_2_BRO",
    "DOAS_2_O3_L",
    "DOAS_2_O3_H",
    "DOAS_2_NO2",
    "DOAS_2_OCLO",
    "DOAS_3_OCLO",
    "DOAS_3_NO2",
    "DOAS_3_O4",
    "DOAS_4_SO2",
    "DOAS_4_O3",
    "DOAS_5_HCHO",
    "DOAS_5_BRO",
    "DOAS_5_O3_L",
    "DOAS_5_O3_H",
    "DOAS_5_NO2",
    "DOAS_5_O4",
    "DOAS_SPARE_1",
    "DOAS_SPARE_2",
    "BIAS_0_H2O",
    "BIAS_0_CO2",
    "BIAS_1_N2O",
    "BIAS_1_H2O",
    "BIAS_1_CH4",
    "BIAS_2_CO",
    "BIAS_2_H2O",
    "BIAS_2_CH4",
    "BIAS_SPARE_1",
    "BIAS_SPARE_2",
    "LEVEL_1B_PRODUCT",
    "INITIALISATION_FILE",
    "CLIMA_DBPR_FILE",
    "CLIMA_DBCL_FILE",
    "CLIMA_DBSF_FILE",
    "CLIMA_DBCS_FILE",
    "CLIMA_DBLB_FILE",
    "CLIMA_DBFM_FILE",
    "CLIMA_DBUC_FILE",
    "CLIMA_DBCC_FILE",
    "AMF_LOOK_UP_FILE",
    "BSPF_LOOK_UP_FILE",
    "AIRC_LOOK_UP_FILE"
};



SCIA_err Read_SPH_SCI_NL__2P (FILE* unit, SPH_SCI_NL__2P *sph)

{
    int err;
    unsigned n;
    char nl[2];
    char *tmp = (char*) sph;
    /* Zeros in the complete structure, so all strings have trailing \0 */
    for (n=0; n<sizeof(SPH_SCI_NL__2P); n++)
	tmp[n] = 0;
    
    err = fscanf(unit,
		 "SPH_DESCRIPTOR=\"%28c\"%1c"
		 "STRIPLINE_CONTINUITY_INDICATOR=%4c%1c"
		 "SLICE_POSITION=%4c%1c"
		 "NUM_SLICES=%4c%1c"
		 "START_TIME=\"%27c\"%1c"
		 "STOP_TIME=\"%27c\"%1c"
		 "START_LAT=%11c<10-6degN>%1c"
		 "START_LONG=%11c<10-6degE>%1c"
		 "STOP_LAT=%11c<10-6degN>%1c"
		 "STOP_LONG=%11c<10-6degE>%1c"
		 "%50c%1c"
		 "FITTING_ERROR_SUM=\"%4c\"%1c"
		 "NO_OF_DOAS_FITTING_WINDOWS=%4c%1c"
		 "DOAS_FITTING_WINDOW_0=\"%9c\"%1c"
		 "DOAS_FITTING_WINDOW_1=\"%9c\"%1c"
		 "DOAS_FITTING_WINDOW_2=\"%9c\"%1c"
		 "DOAS_FITTING_WINDOW_3=\"%9c\"%1c"
		 "DOAS_FITTING_WINDOW_4=\"%9c\"%1c"
		 "DOAS_FITTING_WINDOW_5=\"%9c\"%1c"
		 "DOAS_FITTING_WINDOW_6=\"%9c\"%1c"
		 "NO_OF_BIAS_FITTING_WINDOWS=%4c%1c"
		 "BIAS_FITTING_WINDOW_0=\"%44c\"%1c"
		 "BIAS_FITTING_WINDOW_1=\"%44c\"%1c"
		 "BIAS_FITTING_WINDOW_2=\"%44c\"%1c"
		 "BIAS_FITTING_WINDOW_3=\"%44c\"%1c"
		 "NO_OF_DOAS_MOLECULES=%4c%1c"
		 "DOAS_MOLECULE_00=\"%8c\"%1c"
		 "DOAS_MOLECULE_01=\"%8c\"%1c"
		 "DOAS_MOLECULE_02=\"%8c\"%1c"
		 "DOAS_MOLECULE_03=\"%8c\"%1c"
		 "DOAS_MOLECULE_04=\"%8c\"%1c"
		 "DOAS_MOLECULE_05=\"%8c\"%1c"
		 "DOAS_MOLECULE_06=\"%8c\"%1c"
		 "DOAS_MOLECULE_07=\"%8c\"%1c"
		 "DOAS_MOLECULE_08=\"%8c\"%1c"
		 "DOAS_MOLECULE_09=\"%8c\"%1c"
		 "DOAS_MOLECULE_10=\"%8c\"%1c"
		 "DOAS_MOLECULE_11=\"%8c\"%1c"
		 "DOAS_MOLECULE_12=\"%8c\"%1c"
		 "DOAS_MOLECULE_13=\"%8c\"%1c"
		 "DOAS_MOLECULE_14=\"%8c\"%1c"
		 "DOAS_MOLECULE_15=\"%8c\"%1c"
		 "DOAS_MOLECULE_16=\"%8c\"%1c"
		 "DOAS_MOLECULE_17=\"%8c\"%1c"
		 "DOAS_MOLECULE_18=\"%8c\"%1c"
		 "DOAS_MOLECULE_19=\"%8c\"%1c"
		 "DOAS_MOLECULE_20=\"%8c\"%1c"
		 "DOAS_MOLECULE_21=\"%8c\"%1c"
		 "NO_OF_BIAS_MOLECULES=%4c%1c"
		 "BIAS_MOLECULE_0=\"%8c\"%1c"
		 "BIAS_MOLECULE_1=\"%8c\"%1c"
		 "BIAS_MOLECULE_2=\"%8c\"%1c"
		 "BIAS_MOLECULE_3=\"%8c\"%1c"
		 "BIAS_MOLECULE_4=\"%8c\"%1c"
		 "BIAS_MOLECULE_5=\"%8c\"%1c"
		 "BIAS_MOLECULE_6=\"%8c\"%1c"
		 "BIAS_MOLECULE_7=\"%8c\"%1c"
		 "BIAS_MOLECULE_8=\"%8c\"%1c"
		 "BIAS_MOLECULE_9=\"%8c\"%1c"
		 ,
		 sph->sph_descriptor, nl,
		 sph->stripline_continuity_indicator, nl,
		 sph->slice_position, nl,
		 sph->num_slices, nl,
		 sph->start_time, nl,
		 sph->stop_time, nl,
		 sph->start_lat, nl,
		 sph->start_long, nl,
		 sph->stop_lat, nl,
		 sph->stop_long, nl,
		 sph->spare_1, nl,
		 sph->fitting_error_sum, nl,
		 sph->no_of_doas_fitting_windows, nl,
		 sph->doas_fitting_window[0], nl,
		 sph->doas_fitting_window[1], nl,
		 sph->doas_fitting_window[2], nl,
		 sph->doas_fitting_window[3], nl,
		 sph->doas_fitting_window[4], nl,
		 sph->doas_fitting_window[5], nl,
		 sph->doas_fitting_window[6], nl,
		 sph->no_of_bias_fitting_windows, nl,
		 sph->bias_fitting_window[0], nl,
		 sph->bias_fitting_window[1], nl,
		 sph->bias_fitting_window[2], nl,
		 sph->bias_fitting_window[3], nl,
		 sph->no_of_doas_molecules, nl,
		 sph->doas_molecule[ 0], nl,
		 sph->doas_molecule[ 1], nl,
		 sph->doas_molecule[ 2], nl,
		 sph->doas_molecule[ 3], nl,
		 sph->doas_molecule[ 4], nl,
		 sph->doas_molecule[ 5], nl,
		 sph->doas_molecule[ 6], nl,
		 sph->doas_molecule[ 7], nl,
		 sph->doas_molecule[ 8], nl,
		 sph->doas_molecule[ 9], nl,
		 sph->doas_molecule[10], nl,
		 sph->doas_molecule[11], nl,
		 sph->doas_molecule[12], nl,
		 sph->doas_molecule[13], nl,
		 sph->doas_molecule[14], nl,
		 sph->doas_molecule[15], nl,
		 sph->doas_molecule[16], nl,
		 sph->doas_molecule[17], nl,
		 sph->doas_molecule[18], nl,
		 sph->doas_molecule[19], nl,
		 sph->doas_molecule[20], nl,
		 sph->doas_molecule[21], nl,
		 sph->no_of_bias_molecules, nl,
		 sph->bias_molecule[0], nl,
		 sph->bias_molecule[1], nl,
		 sph->bias_molecule[2], nl,
		 sph->bias_molecule[3], nl,
		 sph->bias_molecule[4], nl,
		 sph->bias_molecule[5], nl,
		 sph->bias_molecule[6], nl,
		 sph->bias_molecule[7], nl,
		 sph->bias_molecule[8], nl,
		 sph->bias_molecule[9], nl );

    if ( strncmp ("SCI_NL__2P", sph->sph_descriptor,10) != 0)
	return SPH_ERROR;	
    if (err != 118)
	return SPH_ERROR;
    return OK;
}



/* Read the DOAS MDS L2N */
void DOAS_L2N_getbin (FILE* unit, DOAS_L2N *var)
{
    int N;
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   ushort_getbin (unit, &var->num_fit_para);
   float_getbin (unit, &var->vcd);
   float_getbin (unit, &var->vcd_err);
   ushort_getbin (unit, &var->flag_vcd_flags);
   float_getbin (unit, &var->slant_col_den);
   float_getbin (unit, &var->err_slant_col);
   float_array_getbin (unit, var->rms_chi_2_gof, 3);
   ushort_getbin (unit, &var->iter_num_fit_win);

   N = (var->num_fit_para * (var->num_fit_para - 1 )) / 2;
   if (N > DOAS_BIAS_MAX_CROSS_COR)
   {
       fprintf (stderr,"Fatal error in DOAS_L2N_getbin(...).\n"
		"DOAS_BIAS_MAX_CROSS_COR to small in scia_defs.h\n");
       exit (255);
   }
   float_array_getbin (unit, var->cross_corr_para, N );

   ushort_getbin (unit, &var->flag_slant_col_flags);
   float_getbin (unit, &var->amf_gr);
   float_getbin (unit, &var->amf_cl);
   float_getbin (unit, &var->refl_ground);
   float_getbin (unit, &var->refl_cloud_top);
   float_getbin (unit, &var->measured_refl);
   ushort_getbin (unit, &var->flag_amf_flags);
}


void DOAS_L2N_array_getbin (FILE* unit, DOAS_L2N *var, int nr)
{
    int n;
    for (n=0; n<nr; n++)
	DOAS_L2N_getbin (unit, &var[n]) ;
}
	

void BIAS_L2N_getbin (FILE* unit, BIAS_L2N *var)
{
    int N;
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   ushort_getbin (unit, &var->num_geophy_param_fit);
   ushort_getbin (unit, &var->num_seg_fit_win);
   float_array_getbin (unit, var->ht_val_and_err, 2);
   ushort_getbin (unit, &var->flag_ht_var_usg);
   float_getbin (unit, &var->trc_gas_vcd);
   float_getbin (unit, &var->err_vcd);
   float_getbin (unit, &var->fit_fc_param);
   float_getbin (unit, &var->err_fit_fc_param);
   float_array_getbin (unit, var->rms_good_fit_win, 4);
   ushort_getbin (unit, &var->iter_num_fit_win);
   
   N =  (var->num_geophy_param_fit * (var->num_geophy_param_fit -1))/2;
   if (N > DOAS_BIAS_MAX_CROSS_COR)
   {
       fprintf (stderr,"Fatal error in BIAS_L2N_getbin(...).\n"
		"DOAS_BIAS_MAX_CROSS_COR to small in scia_defs.h\n");
       exit (255);
   }
   
   float_array_getbin (unit, var->cross_cor_param, N );
   ushort_getbin (unit, &var->flag_bias_vcd_fit_flags);
}

void BIAS_L2N_array_getbin (FILE* unit, BIAS_L2N *var, int nr)
{
    int n;
    for (n=0; n<nr; n++)
	BIAS_L2N_getbin (unit, &var[n]) ;
}


void GeoN_L2N_getbin (FILE* unit, GeoN_L2N *var)
{
   MJD_getbin (unit, &var->dsr_time);
   char_getbin (unit, &var->attach_flag);
   ushort_getbin (unit, &var->integr_time);
   float_array_getbin (unit, var->sol_zen_angle_toa, 3);
   float_array_getbin (unit, var->los_zen_angle_toa, 3);
   float_array_getbin (unit, var->rel_azi_angle_toa, 3);
   float_getbin (unit, &var->sat_geod_ht);
   float_getbin (unit, &var->earth_rad);
   Coord_array_getbin (unit, var->cor_coor_nad, 4);
   Coord_getbin (unit, &var->cen_coor_nad);
}


void GeoN_L2N_array_getbin (FILE* unit, GeoN_L2N *var, int nr)
{
    int n;
    for (n=0; n<nr; n++)
	GeoN_L2N_getbin (unit, &var[n]) ;
}


void CLOUDS_AEROSOL_L2N_getbin (FILE* unit, CLOUDS_AEROSOL_L2N *var)
{
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   ushort_getbin (unit, &var->num_pmd);
   if (var->num_pmd > CLOUDS_AEROSOL_L2N_MAX_PMD)
   {
       fprintf (stderr,"Fatal error in CLOUDS_AEROSOL_getbin(...).\n"
		"CLOUDS_AEROSOL_L2N_MAX_PMD  to small in scia_defs.h\n");
       exit (255);
   }
   float_array_getbin (unit, var->cl_frac, var->num_pmd);
   float_getbin (unit, &var->ave_clo_fract_foot);
   uchar_getbin (unit, &var->qual_frac_cloud_cov);
   float_getbin (unit, &var->cl_top_pres);
   float_getbin (unit, &var->aero_abso_ind);
   float_getbin (unit, &var->equiv_lam_alb);
   ushort_getbin (unit, &var->flag_output_flags);
}

void CLOUDS_AEROSOL_L2N_array_getbin (FILE* unit, CLOUDS_AEROSOL_L2N *var,
				      int nr)
{
    int n;
    for (n=0; n<nr; n++)
	CLOUDS_AEROSOL_L2N_getbin (unit, &var[n]) ;
}    
