
#include "scia_L2O.h"


/* Array with DSD Names */

char DS_NAME_SCI_OL__2P [53][29] = {
    "SUMMARY_QUALITY",
    "STATE_GEOLOCATION",
    "STATIC_PARAM",
    "STATES",
    "GEOLOCATION_NADIR",
    "GEOLOCATION_LIMB",
    "CLOUDS_AEROSOL",
    "NAD_UV0_O3",
    "NAD_UV1_NO2",
    "NAD_UV2_O3",
    "NAD_UV3_BRO",
    "NAD_UV4_H2CO",
    "NAD_UV5_SO2",
    "NAD_UV6_OCLO",
    "NAD_UV7_SPARE",
    "NAD_IR0_H2O",
    "NAD_IR1_CH4",
    "NAD_IR2_N2O",
    "NAD_IR3_CO",
    "NAD_IR4_CO2",
    "NAD_IR5_SPARE",
    "LIM_UV0_O3",
    "LIM_UV1_NO2",
    "LIM_UV2_O3",
    "LIM_UV3_BRO",
    "LIM_UV4_H2CO",
    "LIM_UV5_SO2",
    "LIM_UV6_OCLO",
    "LIM_UV7_SPARE",
    "LIM_IRO_PTH",
    "LIM_IR1_H2O",
    "LIM_IR2_CH4",
    "LIM_IR3_N2O",
    "LIM_IR4_CO",
    "LIM_IR5_SPARE",
    "OCC_UV0_O3",
    "OCC_UV1_NO2",
    "OCC_UV2_O3",
    "OCC_UV3_BRO",
    "OCC_UV4_H2CO",
    "OCC_UV5_SO2",
    "OCC_UV6_OCLO",
    "OCC_UV7_SPARE",
    "OCC_IR0_PTH"
    "OCC_IR1_H2O",
    "OCC_IR2_CH4",
    "OCC_IR3_N2O",
    "OCC_IR4_CO",
    "OCC_IR5_SPARE",
    "NAD_PROFILE_O3",
    "LEVEL_1B_PRODUCT",
    "INITIALISATION_FILE",
    "ECMWF_FILE" };



SCIA_err Read_SPH_SCI_OL__2P (FILE* unit, SPH_SCI_OL__2P *sph)

{
    unsigned n;
    int err;
    char nl[2];
    char *tmp = (char*) sph;
    /* Zeros in the complete structure, so all strings have trailing \0 */
    for (n=0; n<sizeof(SPH_SCI_OL__2P); n++)
	tmp[n] = 0;
    
    err = fscanf(unit,
		 "SPH_DESCRIPTOR=\"%28c\"%1c"
		 "STRIPLINE_CONTINUITY_INDICATOR=%4c%1c"
		 "SLICE_POSITION=%4c%1c"
		 "NUM_SLICES=%4c%1c"
		 "START_TIME=\"%27c\"%1c"
		 "STOP_TIME=\"%27c\"%1c"
		 "START_LAT=%11c<10-6degN>%1c"
		 "START_LONG=%11c<10-6degE>%1c"
		 "STOP_LAT=%11c<10-6degN>%1c"
		 "STOP_LONG=%11c<10-6degE>%1c"
		 "%50c%1c"
		 "DB_SERVER_VER=\"%5c\"%1c"
		 "FITTING_ERROR_SUM=\"%4c\"%1c"
		 "NO_OF_NADIR_FITTING_WINDOWS=%4c%1c"
		 "NAD_FIT_WINDOW_UV0=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV1=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV2=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV3=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV4=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV5=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV6=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_UV7=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_IR0=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_IR1=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_IR2=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_IR3=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_IR4=\"%30c\"%1c"
		 "NAD_FIT_WINDOW_IR5=\"%30c\"%1c"
		 "NO_OF_LIMB_FITTING_WINDOWS=%4c%1c"
		 "LIM_FIT_WINDOW_UV0=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV1=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV2=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV3=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV4=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV5=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV6=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_UV7=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_IR0=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_IR1=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_IR2=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_IR3=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_IR4=\"%30c\"%1c"
		 "LIM_FIT_WINDOW_IR5=\"%30c\"%1c"
		 "NO_OF_OCCL_FITTING_WINDOWS=%4c%1c"
		 "OCC_FIT_WINDOW_UV0=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV1=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV2=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV3=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV4=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV5=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV6=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_UV7=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_IR0=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_IR1=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_IR2=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_IR3=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_IR4=\"%30c\"%1c"
		 "OCC_FIT_WINDOW_IR5=\"%30c\"%1c"
		 "%64c%1c"
		 ,
		 sph->sph_descriptor, nl,
		 sph->stripline_continuity_indicator, nl,
		 sph->slice_position, nl,
		 sph->num_slices, nl,
		 sph->start_time, nl,
		 sph->stop_time, nl,
		 sph->start_lat, nl,
		 sph->start_long, nl,
		 sph->stop_lat, nl,
		 sph->stop_long, nl,
		 sph->spare_1, nl,
		 sph->db_server_ver, nl,
		 sph->fitting_error_sum, nl,
		 sph->no_of_nadir_fitting_windows, nl,
		 sph->nad_fit_window_uv[0], nl,
		 sph->nad_fit_window_uv[1], nl,
		 sph->nad_fit_window_uv[2], nl,
		 sph->nad_fit_window_uv[3], nl,
		 sph->nad_fit_window_uv[4], nl,
		 sph->nad_fit_window_uv[5], nl,
		 sph->nad_fit_window_uv[6], nl,
		 sph->nad_fit_window_uv[7], nl,
		 sph->nad_fit_window_ir[0], nl,
		 sph->nad_fit_window_ir[1], nl,
		 sph->nad_fit_window_ir[2], nl,
		 sph->nad_fit_window_ir[3], nl,
		 sph->nad_fit_window_ir[4], nl,
		 sph->nad_fit_window_ir[5], nl,
		 sph->no_of_limb_fitting_windows, nl,
		 sph->lim_fit_window_uv[0], nl,
		 sph->lim_fit_window_uv[1], nl,
		 sph->lim_fit_window_uv[2], nl,
		 sph->lim_fit_window_uv[3], nl,
		 sph->lim_fit_window_uv[4], nl,
		 sph->lim_fit_window_uv[5], nl,
		 sph->lim_fit_window_uv[6], nl,
		 sph->lim_fit_window_uv[7], nl,
		 sph->lim_fit_window_ir[0], nl,
		 sph->lim_fit_window_ir[1], nl,
		 sph->lim_fit_window_ir[2], nl,
		 sph->lim_fit_window_ir[3], nl,
		 sph->lim_fit_window_ir[4], nl,
		 sph->lim_fit_window_ir[5], nl,
		 sph->no_of_occl_fitting_windows, nl,
		 sph->occ_fit_window_uv[0], nl,
		 sph->occ_fit_window_uv[1], nl,
		 sph->occ_fit_window_uv[2], nl,
		 sph->occ_fit_window_uv[3], nl,
		 sph->occ_fit_window_uv[4], nl,
		 sph->occ_fit_window_uv[5], nl,
		 sph->occ_fit_window_uv[6], nl,
		 sph->occ_fit_window_uv[7], nl,
		 sph->occ_fit_window_ir[0], nl,
		 sph->occ_fit_window_ir[1], nl,
		 sph->occ_fit_window_ir[2], nl,
		 sph->occ_fit_window_ir[3], nl,
		 sph->occ_fit_window_ir[4], nl,
		 sph->occ_fit_window_ir[5], nl,
		 sph->spare_2, nl );

    if ( strncmp ("SCI_OL__2P", sph->sph_descriptor,10) != 0)
	return SPH_ERROR;	
    if (err != 118)
	return SPH_ERROR;
    return OK;
}



void Clouds_Aerosol_L2O_getbin (FILE* unit, Clouds_Aerosol_L2O *var)
{
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   float_getbin (unit, &var->surface_pres);
   float_getbin (unit, &var->cl_frac);
   float_getbin (unit, &var->cl_frac_err);
   ushort_getbin (unit, &var->pmd_read);
   ushort_array_getbin (unit, var->pmd_read_cl, 2);
   float_getbin (unit, &var->cl_top_pres);
   float_getbin (unit, &var->cl_top_pres_err);
   float_getbin (unit, &var->cl_opt_depth);
   float_getbin (unit, &var->cl_opt_depth_err);
   ushort_getbin (unit, &var->cl_type_flags);
   float_getbin (unit, &var->cl_reflectance);
   float_getbin (unit, &var->cl_reflectance_err);
   float_getbin (unit, &var->surf_reflectance);
   float_getbin (unit, &var->surf_reflectance_err);
   ushort_getbin (unit, &var->cloud_flags);
   float_getbin (unit, &var->aero_abso_ind);
   float_getbin (unit, &var->aero_ind_diag);
   ushort_getbin (unit, &var->flag_output_flags);
   ushort_getbin (unit, &var->num_aero_param);
   if (var->num_aero_param > N_CLOUDS_AEROSOL_AERO_PARAM)
   {
       fprintf (stderr, "FATAL error: \n"
		"Clouds_Aerosol_getbin() : N_CLOUDS_AEROSOL_AERO_PARAM "
		"(%d) to small!! %d\n", N_CLOUDS_AEROSOL_AERO_PARAM,
		var->num_aero_param);
   }
   float_array_getbin (unit, var->aero_param, var->num_aero_param);
}



SCIA_err Limb_OL_getbin (FILE* unit, Limb_OL *var)
{
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   char_getbin (unit, &var->method);
   float_getbin (unit, &var->ref_height);
   float_getbin (unit, &var->ref_pressure);
   char_getbin (unit, &var->ref_pressure_source);
   uchar_getbin (unit, &var->n_main);
   uchar_getbin (unit, &var->n_meas);
   uchar_getbin (unit, &var->n1);
   uchar_getbin (unit, &var->n2);
   uchar_getbin (unit, &var->n3);
   uchar_getbin (unit, &var->n4);
				/*  checked fixed MAX sizes */
   if (var->n_main > LIMB_LEVELS ||
       var->n_meas > LIMB_LEVELS)
   {
       fprintf (stderr, "Limb_OL_getbin(): MAX_LIMB_LEVELS "
		"to small!\nn_main = %d\nn_meas = %d\n",
		var->n_main, var->n_meas); 
       exit (1);
   }
   
   if (var->n1 > N_MAX_LIMB_SPECIES)
   {
       fprintf (stderr, "Limb_OL_getbin(): N_MAX_NADIR_OL_PARAMETER "
		"to small!\nn1 = %d\n", var->n1); 
       exit (1);
   }

   if (var->n2 > N_MAX_LIMB_OL_PARAMETER ||
       var->n3 > N_MAX_LIMB_OL_PARAMETER ||
       var->n4 > N_MAX_LIMB_OL_PARAMETER )
   {
       fprintf (stderr, "Limb_OL_getbin(): N_MAX_NADIR_OL_PARAMETER "
		"to small!\nn1 = %d\nn2 = %d\nn3 = %d\n",
		var->n1, var->n2, var->n3); 
       exit (1);
   }
   
   
   float_array_getbin (unit, var->tangent_height, var->n_main);
   float_array_getbin (unit, var->tangent_pressure, var->n_main);
   float_array_getbin (unit, var->tangent_temp, var->n_main);
   Layer_Rec_array_getbin (unit, var->main_species, var->n_main * var->n1);
   Layer_Rec_array_getbin (unit, var->scaled_profiles,
				 var->n_main * var->n4);
   Measurement_Grid_array_getbin (unit, var->measurement_grid, var->n_meas);
   
   ushort_getbin (unit, &var->n_state_vec);

   if ( var->n_state_vec != var->n1 * var->n_main
	                 + var->n2 * var->n_meas + var->n3 )
       return ERROR;   
   State_Vector_array_getbin (unit, var->state_vector, var->n_state_vec);
   
   ushort_getbin (unit, &var->m_f);

   if ( var->m_f != var->n_state_vec * (var->n_state_vec -1) / 2 )
       return ERROR;   
   float_array_getbin (unit, var->correlation_matrix, var->m_f);
   
   float_getbin (unit, &var->rms_fit);
   float_getbin (unit, &var->chi_2_fit);
   float_getbin (unit, &var->goodness_fit);
   ushort_getbin (unit, &var->n_i);
   
   if (var->n_i > N_MAX_LIMB_OL_PARAMETER )
   {
       fprintf (stderr, "Limb_OL_getbin(): N_MAX_NADIR_OL_PARAMETER "
		"to small!\nn_i = %d\n",
		var->n_i); 
       exit (1);
   }

   ushort_getbin (unit, &var->n_used_wl);
   ushort_getbin (unit, &var->n_rejected_wl);
   char_getbin (unit, &var->criteria_flag);
   ushort_getbin (unit, &var->n_res);

   if ( var->n_res != var->n_state_vec * var->n_i )
       return ERROR;   
   float_array_getbin (unit, var->residuals, var->n_res);
   
   ushort_getbin (unit, &var->n_ad);
   
   if (var->n_ad > N_MAX_ADD_DIAG)
   {
       fprintf (stderr, "Limb_OL_getbin(): N_MAX_ADD_DIAG "
		"to small!\nn_ad = %d\n",
		var->n_ad); 
       exit (1);
   }

   float_array_getbin (unit, var->add_diag, var->n_ad);
   return OK;
}



/* This is the dynamic version, clean but complicate in handling */
/*
SCIA_err Limb_OL_getbin (FILE* unit, Limb_OL *var)
{
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   char_getbin (unit, &var->method);
   float_getbin (unit, &var->ref_height);
   float_getbin (unit, &var->ref_pressure);
   char_getbin (unit, &var->ref_pressure_source);
   uchar_getbin (unit, &var->n_main);
   uchar_getbin (unit, &var->n_meas);
   uchar_getbin (unit, &var->n1);
   uchar_getbin (unit, &var->n2);
   uchar_getbin (unit, &var->n3);
   uchar_getbin (unit, &var->n4);
   
   if (! (var->tangent_height = malloc (var->n_main * sizeof(float))))
       	return OUT_OF_MEMORY;       
   float_array_getbin (unit, var->tangent_height, var->n_main);

   if (! (var->tangent_pressure = malloc (var->n_main * sizeof(float))))
       	return OUT_OF_MEMORY;       
   float_array_getbin (unit, var->tangent_pressure, var->n_main);
   
   if (! (var->tangent_temp = malloc (var->n_main * sizeof(float))))
       	return OUT_OF_MEMORY;       
   float_array_getbin (unit, var->tangent_temp, var->n_main);

   if (! (var->main_species = malloc (var->n_main * var->n1
				      * sizeof(Layer_Rec))))
       	return OUT_OF_MEMORY;          
   Layer_Rec_array_getbin (unit, var->main_species, var->n_main * var->n1);
   
   if (! (var->scaled_profiles = malloc (var->n_main * var->n4
				      * sizeof(Scaled_Profiles))))
       	return OUT_OF_MEMORY;          
   Layer_Rec_array_getbin (unit, var->scaled_profiles,
				 var->n_main * var->n4);
   
   if (! (var->measurement_grid = malloc (var->n_meas
				      * sizeof(Measurement_Grid))))
       	return OUT_OF_MEMORY;          
   Measurement_Grid_array_getbin (unit, var->measurement_grid, var->n_meas);
   
   ushort_getbin (unit, &var->n_state_vec);

   if ( var->n_state_vec != var->n1 * var->n_main
	                 + var->n2 * var->n_meas + var->n3 )
       return ERROR;   
   if (! (var->state_vector = malloc (var->n_state_vec
				      * sizeof(State_Vector))))
       	return OUT_OF_MEMORY;          
   State_Vector_array_getbin (unit, var->state_vector, var->n_state_vec);
   
   ushort_getbin (unit, &var->m_f);

   if ( var->m_f != var->n_state_vec * (var->n_state_vec -1) / 2 )
       return ERROR;   
   if (! (var->correlation_matrix = malloc (var->m_f
				      * sizeof(float))))
       	return OUT_OF_MEMORY;             
   float_array_getbin (unit, var->correlation_matrix, var->m_f);
   
   float_getbin (unit, &var->rms_fit);
   float_getbin (unit, &var->chi_2_fit);
   float_getbin (unit, &var->goodness_fit);
   ushort_getbin (unit, &var->n_i);
   ushort_getbin (unit, &var->n_used_wl);
   ushort_getbin (unit, &var->n_rejected_wl);
   char_getbin (unit, &var->criteria_flag);
   ushort_getbin (unit, &var->n_res);

   if ( var->n_res != var->n_state_vec * var->n_i )
       return ERROR;   
   if (! (var->residuals = malloc (var->n_res
				      * sizeof(float))))
       	return OUT_OF_MEMORY;             
   float_array_getbin (unit, var->residuals, var->n_res);
   
   ushort_getbin (unit, &var->n_ad);

   if (! (var->add_diag = malloc (var->n_ad
				      * sizeof(float))))
       	return OUT_OF_MEMORY;             
   float_array_getbin (unit, var->add_diag, var->n_ad);
   return OK;
}
*/

/*  Free memory allocated by  Limb_OL_getbin (FILE* unit, Limb_OL *var)
 */
/*
SCIA_err Limb_OL_free (FILE* unit, Limb_OL *var)
{
    free (var->tangent_height);
    free (var->tangent_pressure);
    free (var->tangent_temp);
    free (var->main_species);
    free (var->scaled_profiles);
    free (var->measurement_grid);
    free (var->state_vector);
    free (var->correlation_matrix);
    free (var->residuals);
    free (var->add_diag);
   return OK;
}
*/


void Layer_Rec_array_getbin (FILE* unit, Layer_Rec *var, int nr)
{
    int n;
    for (n=0; n<nr; n++)
    {
	float_getbin (unit, &var[n].tang_vmr);
	float_getbin (unit, &var[n].err_tang_vmr);
	float_getbin (unit, &var[n].vert_col);
	float_getbin (unit, &var[n].err_vert_col);
    }
}


void Measurement_Grid_array_getbin (FILE* unit, Measurement_Grid *var, int nr)
{
    int n;
    for (n=0; n<nr; n++)
    {
	MJD_getbin (unit, &var[n].dsr_time);
	float_getbin (unit, &var[n].tangent_height);
	float_getbin (unit, &var[n].tangent_pressure);
	float_getbin (unit, &var[n].tangent_temp);
	uchar_getbin (unit, &var[n].num_windows);
	float_getbin (unit, &var[n].win_min);
	float_getbin (unit, &var[n].win_max);
    }
}


void Nad_Profile_O3_getbin (FILE* unit, Nad_Profile_O3 *var)
{
   MJD_getbin (unit, &var->dsr_time);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
}


void Nadir_OL_getbin (FILE* unit, Nadir_OL *var)
{
    int n1,n2, n1cc, n2cc;
   MJD_getbin (unit, &var->dsr_time);
   uint_getbin (unit, &var->dsr_length);
   char_getbin (unit, &var->quality_flag);
   ushort_getbin (unit, &var->integr_time);
   ushort_getbin (unit, &var->num_vcd);
   if (var->num_vcd > N_MAX_NADIR_OL_PARAMETER)
   {
       fprintf (stderr, "Nadir_OL_getbin(): N_MAX_NADIR_OL_PARAMETER) "
		"to small!\nnum_vcd = %d\n", var->num_vcd); 
       exit (1);
   }
   float_array_getbin (unit, var->vcd, var->num_vcd);
   float_array_getbin (unit, var->vcd_err, var->num_vcd);
   ushort_getbin (unit, &var->flag_vcd_flags);
   float_getbin (unit, &var->slant_col_den);
   float_getbin (unit, &var->err_slant_col);
   ushort_getbin (unit, &var->num_linear_param);
   ushort_getbin (unit, &var->num_non_linear_param);
   n1 = var->num_linear_param;
   n2 = var->num_non_linear_param;
   n1cc = (n1 * (n1-1)) / 2; 	/* Number of Cross correlation parameters */
   n2cc = (n2 * (n2-1)) / 2;   
   if (n1 > N_MAX_NADIR_OL_PARAMETER ||
       n2 > N_MAX_NADIR_OL_PARAMETER ||
       n1cc > N_MAX_NADIR_OL_CC_PARAMETER ||
       n2cc > N_MAX_NADIR_OL_CC_PARAMETER        
       )
   {
       fprintf (stderr, "Nadir_OL_getbin(): N_MAX_NADIR_OL_PARAMETER (%d) "
		"to small!\n"
		"N_MAX_NADIR_OL_CC_PARAMETER (%d) "
		"to small!\n"
		"num_linear_param = %d\n"
		"num_non_linear_param = %d\n"
		"num_linear_cross_cor_param = %d\n"
		"num_non_linear_cross_cor_param = %d\n"
		"     ",
		N_MAX_NADIR_OL_PARAMETER,
		N_MAX_NADIR_OL_CC_PARAMETER,
		n1,n2,n1cc,n2cc); 
       exit (1);
   }

   float_array_getbin (unit, var->linear_fit_param, n1);
   float_array_getbin (unit, var->linear_fit_param_err, n1);
   float_array_getbin (unit, var->linear_fit_cross_corr, n1cc);
   float_array_getbin (unit, var->non_linear_fit_param, n2);
   float_array_getbin (unit, var->non_linear_fit_param_err, n2);
   float_array_getbin (unit, var->non_linear_fit_cross_corr, n2cc);
   float_getbin (unit, &var->rms_fit);
   float_getbin (unit, &var->chi_2_fit);
   float_getbin (unit, &var->goodness_fit);
   ushort_getbin (unit, &var->iter_count_nonlin_fit);
   ushort_getbin (unit, &var->fit_flags);
   float_getbin (unit, &var->amf_gr);
   float_getbin (unit, &var->amf_gr_err);
   float_getbin (unit, &var->amf_cl);
   float_getbin (unit, &var->amf_cl_err);
   ushort_getbin (unit, &var->flag_amf_flags);
   float_getbin (unit, &var->temp_ref);
}



void State_Vector_array_getbin (FILE* unit, State_Vector *var, int nr)
{
    int n;
    for (n=0; n<nr; n++)
    {
	float_getbin (unit, &var[n].value);
	float_getbin (unit, &var[n].error);
	uchar_array_getbin (unit, var[n].type, 4);
    }
}

void Static_Param_getbin (FILE* unit, Static_Param *var)
{
   char_getbin (unit, &var->static_params);
}


void Summary_Quality_getbin (FILE* unit, Summary_Quality *var)
{
   MJD_getbin (unit, &var->dsr_time);
   char_getbin (unit, &var->attach_flag);
   uchar_array_getbin (unit, var->sq_geophy_para, 180);
}


void States_getbin (FILE* unit, States *var)
{
   MJD_getbin (unit, &var->dsr_time);
   char_getbin (unit, &var->attach_flag);
   ushort_getbin (unit, &var->state_id);
   ushort_getbin (unit, &var->duration_scan_state);
   ushort_getbin (unit, &var->longest_int_time);
   ushort_getbin (unit, &var->shortest_int_time);
   ushort_getbin (unit, &var->num_obs_state);
}


void States_array_getbin (FILE* unit, States *var, int nr)
{
    int n;
    for (n=0; n< nr; n++)
	States_getbin (unit, var+n);
}
