#ifndef  __SCIA_LO                       /* Avoid multiple includes */
#define  __SCIA_LO

#include "scia_defs.h"
#include "scia_common.h"
#include "bin_read.h"

#define N_CLOUDS_AEROSOL_AERO_PARAM 10
#define N_MAX_NADIR_OL_PARAMETER 15
#define N_MAX_NADIR_OL_CC_PARAMETER 105	 /* (15*14)/2 */
extern char DS_NAME_SCI_OL__2P [53][29];

/* DSD name enum */

typedef enum DSD_SCI_OL__2P
{
    SCI_OL__2P_SUMMARY_QUALITY,
    SCI_OL__2P_STATE_GEOLOCATION,
    SCI_OL__2P_STATIC_PARAM,
    SCI_OL__2P_STATES,
    SCI_OL__2P_GEOLOCATION_NADIR,
    SCI_OL__2P_GEOLOCATION_LIMB,
    SCI_OL__2P_CLOUDS_AEROSOL,
    SCI_OL__2P_NAD_UV0_O3,
    SCI_OL__2P_NAD_UV1_NO2,
    SCI_OL__2P_NAD_UV2_O3,
    SCI_OL__2P_NAD_UV3_BRO,
    SCI_OL__2P_NAD_UV4_H2CO,
    SCI_OL__2P_NAD_UV5_SO2,
    SCI_OL__2P_NAD_UV6_OCLO,
    SCI_OL__2P_NAD_UV7_SPARE,
    SCI_OL__2P_NAD_IR0_H2O,
    SCI_OL__2P_NAD_IR1_CH4,
    SCI_OL__2P_NAD_IR2_N2O,
    SCI_OL__2P_NAD_IR3_CO,
    SCI_OL__2P_NAD_IR4_CO2,
    SCI_OL__2P_NAD_IR5_SPARE,
    SCI_OL__2P_LIM_UV0_O3,
    SCI_OL__2P_LIM_UV1_NO2,
    SCI_OL__2P_LIM_UV2_O3,
    SCI_OL__2P_LIM_UV3_BRO,
    SCI_OL__2P_LIM_UV4_H2CO,
    SCI_OL__2P_LIM_UV5_SO2,
    SCI_OL__2P_LIM_UV6_OCLO,
    SCI_OL__2P_LIM_UV7_SPARE,
    SCI_OL__2P_LIM_IR0_PTH,
    SCI_OL__2P_LIM_IR1_H2O,
    SCI_OL__2P_LIM_IR2_CH4,
    SCI_OL__2P_LIM_IR3_N2O,
    SCI_OL__2P_LIM_IR4_CO,
    SCI_OL__2P_LIM_IR5_SPARE,
    SCI_OL__2P_OCC_UV0_O3,
    SCI_OL__2P_OCC_UV1_NO2,
    SCI_OL__2P_OCC_UV2_O3,
    SCI_OL__2P_OCC_UV3_BRO,
    SCI_OL__2P_OCC_UV4_H2CO,
    SCI_OL__2P_OCC_UV5_SO2,
    SCI_OL__2P_OCC_UV6_OCLO,
    SCI_OL__2P_OCC_UV7_SPARE,
    SCI_OL__2P_OCC_IR0_PTH,
    SCI_OL__2P_OCC_IR0_H2O,
    SCI_OL__2P_OCC_IR1_CH4,
    SCI_OL__2P_OCC_IR2_N2O,
    SCI_OL__2P_OCC_IR3_CO,
    SCI_OL__2P_OCC_IR4_SPARE,
    SCI_OL__2P_NAD_PROFILE_O3,
    SCI_OL__2P_LEVEL_1B_PRODUCT,
    SCI_OL__2P_INITIALISATION_FILE,
    SCI_OL__2P_ECMWF_FILE,
    SCI_OL__2P_MAX_DS_NAME
} DSD_SCI_OL__2P;



typedef struct SPH_SCI_OL__2P {
        /*  SPH descriptor */
    char sph_descriptor[29];
        /*  Value: +000 = No stripline continuity, the product is a complete
            segment Other: Stripline Counter */
    char stripline_continuity_indicator[5];
        /*  Value: +001 to NUM_SLICES Default value if no stripline continuity
            = +001 */
    char slice_position[5];
        /*  Number of slices in this stripline Default value if no continuity
            = +001 */
    char num_slices[5];
        /*  Start time of the measurement data in this product. UTC time of
            first MDSR */
    char start_time[28];
        /*  Time of the end of the measurement data in this product (last MDSR
            time). UTC time of last MDSR */
    char stop_time[28];
        /*  Latitude of the satellite nadir at the START_TIME. WGS84 latitude,
            positive = North */
    char start_lat[12];
        /*  Longitude of the satellite nadir at the START_TIME. WGS84 longitude,
            positive = East, 0 = Greenwich */
    char start_long[12];
        /*  Latitude of the satellite nadir at the STOP_TIME. WGS84 latitude,
            positive = North */
    char stop_lat[12];
        /*  Longitude of the satellite nadir at the STOP_TIME. WGS84 longitude,
            positive = East, 0 = Greenwich */
    char stop_long[12];
        /*  Spare */
    char spare_1[50];
        /*  Database Server Version Number. (e.g. &quot;02.15&quot;) */
    char db_server_ver[6];
        /*  Quality summary of the fitting errors. (:GOOD&quot;, &quot;FAIR&quot;
            or &quot;BAD &quot;) */
    char fitting_error_sum[5];
        /*  Number of Nadir fitting windows */
    char no_of_nadir_fitting_windows[5];
        /*  Wavelength range of the fitting window. A pattern of two wavelengths
            (e.g &quot; 325- 335&quot;). */
    char nad_fit_window_uv[8][31];
        /*  Wavelength range of the fitting window. A pattern of two wavelengths
            (e.g &quot; 325- 335&quot;). */
    char nad_fit_window_ir[6][31];
        /*  Number of Limb fitting windows */
    char no_of_limb_fitting_windows[5];
        /*  Wavelength range of the fitting window. A pattern of two wavelengths
            (e.g &quot; 325- 335&quot;). */
    char lim_fit_window_uv[8][31];
        /*  Wavelength range of the fitting window. A pattern of two wavelengths
            (e.g &quot; 325- 335&quot;). */
    char lim_fit_window_ir[6][31];
        /*  Number of Limb fitting windows */
    char no_of_occl_fitting_windows[5];
        /*  Wavelength range of the fitting window. A pattern of two wavelengths
            (e.g &quot; 325- 335&quot;). */
    char occ_fit_window_uv[8][31];
        /*  Wavelength range of the fitting window. A pattern of two wavelengths
            (e.g &quot; 325- 335&quot;). */
    char occ_fit_window_ir[6][31];
        /*  Spare */
    char spare_2[64];
} SPH_SCI_OL__2P ;


typedef struct Clouds_Aerosol_L2O {
        /*  Start Time of DSR */
    MJD dsr_time;
        /*  Length of this DSR in bytes */
    unsigned int dsr_length;
        /*  Quality Indicator (-1 for blank MDSR, 0 otherwise) */
    char quality_flag;
        /*  Integration time for this DSR */
    unsigned short integr_time;
        /*  Surface pressure */
    float surface_pres;
        /*  Cloud fraction */
    float cl_frac;
        /*  Error on cloud fraction */
    float cl_frac_err;
        /*  Number of PMD sub-pixels for this DSR */
    unsigned short pmd_read;
        /*  Number of PMD sub-pixels determined to be totally clouded or
            cloud-free */
    unsigned short pmd_read_cl[2];
        /*  Cloud-top pressure */
    float cl_top_pres;
        /*  Error on cloud-top pressure */
    float cl_top_pres_err;
        /*  Cloud optical depth */
    float cl_opt_depth;
        /*  Error on cloud optical depth */
    float cl_opt_depth_err;
        /*  Cloud type */
    unsigned short cl_type_flags;
        /*  Cloud top bi-directional reflectance */
    float cl_reflectance;
        /*  Error on cloud top bi-directional reflectance */
    float cl_reflectance_err;
        /*  Effective Lambertian surface reflectance */
    float surf_reflectance;
        /*  Error on effective Lambertian surface reflectance */
    float surf_reflectance_err;
        /*  Flag describing the cloud parameter output */
    unsigned short cloud_flags;
        /*  Absorbing aerosol indicator */
    float aero_abso_ind;
        /*  Aerosol indicator diagnostic */
    float aero_ind_diag;
        /*  Flag describing the absorbing aerosol indicator output */
    unsigned short flag_output_flags;
        /*  Number of additional aerosol parameters (Na) */
    unsigned short num_aero_param;
        /*  Additional aerosol parameters */
    float aero_param[N_CLOUDS_AEROSOL_AERO_PARAM];
} Clouds_Aerosol_L2O ;


typedef struct Geolocation_Limb {
        /*  Start Time of DSR */
    MJD dsr_time;
        /*  Attachment Flag */
    char attach_flag;
        /*  Integration time for this geolocation entity */
    unsigned short integr_time;
        /*  Solar zenith angles of the start, middle and end of the integration
            time at TOA */
    int sol_zen_angle_toa[3];
        /*  Line-of-sight zenith angles of start, middle and end of the integration
            time at TOA */
    int los_zen_angle_toa[3];
        /*  Relative azimuth angles of start, middle and end of the integration
            time at TOA */
    int rel_azi_angle_toa[3];
        /*  Satellite geodetic height at the middle of the integration time */
    unsigned int sat_geod_ht;
        /*  Earth radius at the middle of the integration time */
    unsigned int earth_rad;
        /*  Sub-satelite point at the middle of the integration time */
    Coord sub_sat_point;
        /*  Co-ordinates of tangent ground points of the start, middle and
            end of the integration time */
    Coord tangent_coord[3];
        /*  Tangent height of the start, middle and end of the integration
            time */
    unsigned int tangent_height[3];
} Geolocation_Limb ;


typedef struct Geolocation_Nadir {
        /*  Start Time of DSR */
    MJD dsr_time;
        /*  Attachment Flag */
    char attach_flag;
        /*  Integration time for this geolocation entity */
    unsigned short integr_time;
        /*  Solar zenith angles of the start, middle and end of the integration
            time at TOA */
    int sol_zen_angle_toa[3];
        /*  Line-of-sight zenith angles of start, middle and end of the integration
            time at TOA */
    int los_zen_angle_toa[3];
        /*  Relative azimuth angles of start, middle and end of the integration
            time at TOA */
    int rel_azi_angle_toa[3];
        /*  Satellite geodetic height at the middle of the integration time */
    unsigned int sat_geod_ht;
        /*  Earth radius at the middle of the integration time */
    unsigned int earth_rad;
        /*  Sub-satelite point at the middle of the integration time */
    Coord sub_sat_point;
        /*  4 corner coordinates of the nadir ground pixel (the first coordinate
            is the one which is the first in time and flight direction, the
            second the first in time and last in flight direction, the third
            the last in time and first in flight direction and the fo */
    Coord cor_coor_nad[4];
        /*  Centre coordinate of the nadir ground pixel */
    Coord cen_coor_nad;
} Geolocation_Nadir ;


typedef struct Layer_Rec {
        /*  Tangent layer volume mixing ratio */
    float tang_vmr;
        /*  Error on the tangent volume mixing ratio */
    float err_tang_vmr;
        /*  Vertical column density above lower layer boundary */
    float vert_col;
        /*  Error on the vertical column density above lower layer boundary */
    float err_vert_col;
} Layer_Rec ;


typedef struct Measurement_Grid {
        /*  Start Time of the measurment at that specific layer */
    MJD dsr_time;
        /*  Mean tangent height of measurement */
    float tangent_height;
        /*  Pressure at tangent height */
    float tangent_pressure;
        /*  Temperature at tangent height */
    float tangent_temp;
        /*  Number of fitting windows */
    unsigned char num_windows;
        /*  Minimum wavelength over all fitting windows */
    float win_min;
        /*  Maximum wavelength over all fitting windows */
    float win_max;
} Measurement_Grid ;


typedef struct Scaled_Profiles {
        /*  Tangent layer volume mixing ratio */
    float tang_vmr;
        /*  Error on the tangent volume mixing ratio */
    float err_tang_vmr;
        /*  Vertical column density above lower layer boundary */
    float vert_col;
        /*  Error on the vertical column density above lower layer boundary */
    float err_vert_col;
} Scaled_Profiles ;


typedef struct State_Vector {
        /*  Value of the state vector entry */
    float value;
        /*  Error of the value of the state vector entry */
    float error;
        /*  Type of the value of the state vector entry (Annotation) */
    unsigned char type[4];
} State_Vector ;


/* This is the dynamic version, clean but complicate in handling */


/* typedef struct Limb_OL { */
/*         /\*  Start Time of DSR *\/ */
/*     MJD dsr_time; */
/*         /\*  Length of this DSR in bytes *\/ */
/*     unsigned int dsr_length; */
/*         /\*  Quality Indicator (-1 for blank MDSR, 0 otherwise) *\/ */
/*     char quality_flag; */
/*         /\*  Retrieval method. 'O' = optimal estimation, 'N' = non-linear */
/*             least sqaures fitting, etc. *\/ */
/*     unsigned short integr_time; */
/*         /\*  Number of vertical column densities (Nv) *\/ */
/*     char method; */
/*         /\*  Height of the reference pressure *\/ */
/*     float ref_height; */
/*         /\*  Reference pressure for hydrostatic equilibrium *\/ */
/*     float ref_pressure; */
/*         /\*  Reference pressure source. 'E' = ECMWF, 'C' = climatology, etc. *\/ */
/*     char ref_pressure_source; */
/*         /\*  Number of retrieval levels. *\/ */
/*     unsigned char n_main; */
/*         /\*  Number of used measurement levels *\/ */
/*     unsigned char n_meas; */
/*         /\*  Number of fitted main gas species *\/ */
/*     unsigned char n1; */
/*         /\*  Number of fitted closure parameters *\/ */
/*     unsigned char n2; */
/*         /\*  Number of fitted other parameters *\/ */
/*     unsigned char n3; */
/*         /\*  Number of fitted scaling parameters for auxilliary gasses *\/ */
/*     unsigned char n4; */
/*         /\*  Tangent height at the lower layer boundary. [n_main] *\/ */
/*     float *tangent_height; */
/*         /\*  Tangent layer pressure at the lower layer boundary. [n_main] *\/ */
/*     float *tangent_pressure; */
/*         /\*  Tangent layer temperature (mean). [n_main] *\/ */
/*     float *tangent_temp; */
/*         /\*  Main species which have been fitted on the coarse forward model */
/*             grid. [n_main * n1] *\/ */
/*     Layer_Rec *main_species; */
/*         /\*  Scaled profiles which have been fitted on the coarse forward */
/*             model grid. [n_main * n4] *\/ */
/*     Layer_Rec *scaled_profiles; */
/*         /\*  Measurement Grid. [n_meas] *\/ */
/*     Measurement_Grid *measurement_grid; */
/*         /\*  State vector size. (n_state_vec = n1 * n_main + n2 * n_meas + n3). *\/ */
/*     unsigned short n_state_vec; */
/*         /\*  State vector. [n_state_vec] *\/ */
/*     State_Vector *state_vector; */
/*         /\*  Correlation matrix size (m_f = 1/2 * n_state_vec * (n_state_vec */
/*             -1)). *\/ */
/*     unsigned short m_f; */
/*         /\*  Correlation Matrix of the fit. [m_f] *\/ */
/*     float *correlation_matrix; */
/*         /\*  RMS of the fit *\/ */
/*     float rms_fit; */
/*         /\*  Chi^2 of the fit *\/ */
/*     float chi_2_fit; */
/*         /\*  Goodness of the fit *\/ */
/*     float goodness_fit; */
/*         /\*  Number of iterations for the fit. *\/ */
/*     unsigned short n_i; */
/*         /\*  Number of used wavelengths *\/ */
/*     unsigned short n_used_wl; */
/*         /\*  Number of rejected wavelengths *\/ */
/*     unsigned short n_rejected_wl; */
/*         /\*  Convergency criteria *\/ */
/*     char criteria_flag; */
/*         /\*  Residuals size (n_res = n_st_vec * n_i) *\/ */
/*     unsigned short n_res; */
/*         /\*  Iteration step state vector residuals. [n_res] *\/ */
/*     float *residuals; */
/*         /\*  Number of additional diagnostics *\/ */
/*     unsigned short n_ad; */
/*         /\*  Additional diagnostics *\/ */
/*     float *add_diag; */
/* } Limb_OL ; */


				/* n2, n3, n4 */
#define N_MAX_LIMB_OL_PARAMETER 20
#define N_MAX_LIMB_SPECIES 6	/* at least 3 are used in IR retrieval */
				/* MAX_LIMB_LEVELS (35) is used for
				   n_main, n_meas*/
#define N_MAX_LIMB_STATE_VEKTOR N_MAX_LIMB_SPECIES * LIMB_LEVELS + N_MAX_LIMB_OL_PARAMETER * LIMB_LEVELS + N_MAX_LIMB_OL_PARAMETER
#define N_MAX_LIMB_COR_MATRIX  N_MAX_LIMB_STATE_VEKTOR * (N_MAX_LIMB_STATE_VEKTOR -1) / 2
#define N_MAX_RESIDUAL N_MAX_LIMB_STATE_VEKTOR * N_MAX_LIMB_OL_PARAMETER
#define N_MAX_ADD_DIAG 1000

typedef struct Limb_OL {
        /*  Start Time of DSR */
    MJD dsr_time;
        /*  Length of this DSR in bytes */
    unsigned int dsr_length;
        /*  Quality Indicator (-1 for blank MDSR, 0 otherwise) */
    char quality_flag;
        /*  Retrieval method. 'O' = optimal estimation, 'N' = non-linear
            least sqaures fitting, etc. */
    unsigned short integr_time;
        /*  Number of vertical column densities (Nv) */
    char method;
        /*  Height of the reference pressure */
    float ref_height;
        /*  Reference pressure for hydrostatic equilibrium */
    float ref_pressure;
        /*  Reference pressure source. 'E' = ECMWF, 'C' = climatology, etc. */
    char ref_pressure_source;
        /*  Number of retrieval levels. */
    unsigned char n_main;
        /*  Number of used measurement levels */
    unsigned char n_meas;
        /*  Number of fitted main gas species */
    unsigned char n1;
        /*  Number of fitted closure parameters */
    unsigned char n2;
        /*  Number of fitted other parameters */
    unsigned char n3;
        /*  Number of fitted scaling parameters for auxilliary gasses */
    unsigned char n4;
        /*  Tangent height at the lower layer boundary. [n_main] */
    float tangent_height[LIMB_LEVELS];
        /*  Tangent layer pressure at the lower layer boundary. [n_main] */
    float tangent_pressure[LIMB_LEVELS];
        /*  Tangent layer temperature (mean). [n_main] */
    float tangent_temp[LIMB_LEVELS];
        /*  Main species which have been fitted on the coarse forward model
            grid. [n_main * n1] */
    Layer_Rec main_species[LIMB_LEVELS * N_MAX_LIMB_SPECIES];
        /*  Scaled profiles which have been fitted on the coarse forward
            model grid. [n_main * n4] */
    Layer_Rec scaled_profiles[LIMB_LEVELS * N_MAX_LIMB_OL_PARAMETER];
        /*  Measurement Grid. [n_meas] */
    Measurement_Grid measurement_grid [LIMB_LEVELS];
        /*  State vector size. (n_state_vec = n1 * n_main + n2 * n_meas + n3). */
    unsigned short n_state_vec ;
        /*  State vector. [n_state_vec] */
    State_Vector state_vector[N_MAX_LIMB_STATE_VEKTOR];
        /*  Correlation matrix size (m_f = 1/2 * n_state_vec * (n_state_vec
            -1)). */
    unsigned short m_f;
        /*  Correlation Matrix of the fit. [m_f] */
    float correlation_matrix[N_MAX_LIMB_COR_MATRIX];
        /*  RMS of the fit */
    float rms_fit;
        /*  Chi^2 of the fit */
    float chi_2_fit;
        /*  Goodness of the fit */
    float goodness_fit;
        /*  Number of iterations for the fit. */
    unsigned short n_i;
        /*  Number of used wavelengths */
    unsigned short n_used_wl;
        /*  Number of rejected wavelengths */
    unsigned short n_rejected_wl;
        /*  Convergency criteria */
    char criteria_flag;
        /*  Residuals size (n_res = n_st_vec * n_i) */
    unsigned short n_res;
        /*  Iteration step state vector residuals. [n_res] */
    float residuals [N_MAX_RESIDUAL];
        /*  Number of additional diagnostics */
    unsigned short n_ad;
        /*  Additional diagnostics */
    float add_diag[N_MAX_ADD_DIAG];
} Limb_OL ;


typedef struct Nad_Profile_O3 {
        /*  Start Time of DSR */
    MJD dsr_time;
        /*  Quality Indicator (-1 for blank MDSR, 0 otherwise) */
    char quality_flag;
        /*  Integration time for this DSR */
    unsigned short integr_time;
} Nad_Profile_O3 ;




typedef struct Nadir_OL {
        /*  Start Time of DSR */
    MJD dsr_time;
        /*  Length of this DSR in bytes */
    unsigned int dsr_length;
        /*  Quality Indicator (-1 for blank MDSR, 0 otherwise) */
    char quality_flag;
        /*  Integration time for this DSR */
    unsigned short integr_time;
        /*  Number of vertical column densities (Nv) */
    unsigned short num_vcd;
        /*  Vertical column density (VCD) */
    float vcd[N_MAX_NADIR_OL_PARAMETER];
        /*  Error on the VCD */
    float vcd_err[N_MAX_NADIR_OL_PARAMETER];
        /*  Flag describing the VCD output */
    unsigned short flag_vcd_flags;
        /*  Effective Slant column density (ESC) */
    float slant_col_den;
        /*  Error on slant column density */
    float err_slant_col;
        /*  Number of linear fitted parameters (n1) */
    unsigned short num_linear_param;
        /*  Number of non-linear fitted parameters (n2) */
    unsigned short num_non_linear_param;
        /*  Linear fitted parameters */
    float linear_fit_param[N_MAX_NADIR_OL_PARAMETER];
        /*  Errors on the linear fitted parameters */
    float linear_fit_param_err[N_MAX_NADIR_OL_PARAMETER];
        /*  Cross-correlation entries of the linear fit. */
    float linear_fit_cross_corr[N_MAX_NADIR_OL_CC_PARAMETER];
        /*  Non-linear fitted parameters */
    float non_linear_fit_param[N_MAX_NADIR_OL_PARAMETER];
        /*  Errors on the non-linear fitted parameters */
    float non_linear_fit_param_err[N_MAX_NADIR_OL_PARAMETER];
        /*  Cross-correlation entries of the non-linear fit. */
    float non_linear_fit_cross_corr[N_MAX_NADIR_OL_CC_PARAMETER];
        /*  RMS of the fit */
    float rms_fit;
        /*  Chi^2 of the fit */
    float chi_2_fit;
        /*  Goodness of the fit */
    float goodness_fit;
        /*  Number of iterations for the non-linear fit */
    unsigned short iter_count_nonlin_fit;
        /*  Fitting output flag */
    unsigned short fit_flags;
        /*  AMF to ground */
    float amf_gr;
        /*  Error on AMF to ground */
    float amf_gr_err;
        /*  AMF to cloud-top */
    float amf_cl;
        /*  Error on AMF to cloud-top */
    float amf_cl_err;
        /*  AMF output flag */
    unsigned short flag_amf_flags;
        /*  Temperature of reference spectrum */
    float temp_ref;
} Nadir_OL ;



typedef struct Static_Param {
        /*  Static parameter initialisation file in XML format */
    char static_params;
} Static_Param ;


typedef struct Summary_Quality {
        /*  Start time of the scan phase of the state */
    MJD dsr_time;
        /*  Attachment Flag (set to 1 if all MDSRs corresponding to this ADSR
            are blank, set to zero otherwise) */
    char attach_flag;
        /*  Summary of quality for the different geophysical parameters
            (cloud and trace gas concentration) of the entire state (some
            unused) */
    unsigned char sq_geophy_para[180];
} Summary_Quality ;



typedef struct States {
        /*  Start time of the scan phase of the state */
    MJD dsr_time;
        /*  Attachment Flag (set to 1 if all MDSRs corresponding to this ADSR
            are blank, set to zero otherwise) */
    char attach_flag;
        /*  Identifier of the state */
    unsigned short state_id;
        /*  Duration of the scan phase of the state */
    unsigned short duration_scan_state;
        /*  Longest integration time */
    unsigned short longest_int_time;
        /*  Shortest integration time */
    unsigned short shortest_int_time;
        /*  Number of observations in the state */
    unsigned short num_obs_state;
} States ;




void Clouds_Aerosol_L2O_getbin (FILE* unit, Clouds_Aerosol_L2O *var);
void Layer_Rec_array_getbin (FILE* unit, Layer_Rec *var, int nr);
void Measurement_Grid_array_getbin (FILE* unit, Measurement_Grid *var, int nr);
void Nad_Profile_O3_getbin (FILE* unit, Nad_Profile_O3 *var);
void Nadir_OL_getbin (FILE* unit, Nadir_OL *var);
void Static_Param_getbin (FILE* unit, Static_Param *var);
void Summary_Quality_getbin (FILE* unit, Summary_Quality *var);
void State_Vector_array_getbin (FILE* unit, State_Vector *var, int nr);
void States_getbin (FILE* unit, States *var);
void States_array_getbin (FILE* unit, States *var, int nr);


SCIA_err Read_SPH_SCI_OL__2P (FILE* unit, SPH_SCI_OL__2P *sph);
SCIA_err Limb_OL_getbin (FILE* unit, Limb_OL *var);
SCIA_err Limb_OL_free (FILE* unit, Limb_OL *var);



#endif /* __SCIA_L2 */

